/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the TemplatesGroupedList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplatesGroupedList{}

// TemplatesGroupedList struct for TemplatesGroupedList
type TemplatesGroupedList struct {
	Results []TemplateGrouped `json:"results"`
	Total int32 `json:"total"`
}

// NewTemplatesGroupedList instantiates a new TemplatesGroupedList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplatesGroupedList(results []TemplateGrouped, total int32) *TemplatesGroupedList {
	this := TemplatesGroupedList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewTemplatesGroupedListWithDefaults instantiates a new TemplatesGroupedList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplatesGroupedListWithDefaults() *TemplatesGroupedList {
	this := TemplatesGroupedList{}
	return &this
}

// GetResults returns the Results field value
func (o *TemplatesGroupedList) GetResults() []TemplateGrouped {
	if o == nil {
		var ret []TemplateGrouped
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *TemplatesGroupedList) GetResultsOk() ([]TemplateGrouped, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *TemplatesGroupedList) SetResults(v []TemplateGrouped) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *TemplatesGroupedList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *TemplatesGroupedList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *TemplatesGroupedList) SetTotal(v int32) {
	o.Total = v
}

func (o TemplatesGroupedList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplatesGroupedList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableTemplatesGroupedList struct {
	value *TemplatesGroupedList
	isSet bool
}

func (v NullableTemplatesGroupedList) Get() *TemplatesGroupedList {
	return v.value
}

func (v *NullableTemplatesGroupedList) Set(val *TemplatesGroupedList) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplatesGroupedList) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplatesGroupedList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplatesGroupedList(val *TemplatesGroupedList) *NullableTemplatesGroupedList {
	return &NullableTemplatesGroupedList{value: val, isSet: true}
}

func (v NullableTemplatesGroupedList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplatesGroupedList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


